// tinylist.cpp
#include <iostream.h>
#include <iomanip.h>
#include <new.h>

#include "dynstrlb.h"

class node {
		String data;
		node *next;
		node *prev;
	public:
		node();
		~node();
		node(char *str);
		node(String &indata);
		void connect(node *nodep);
		node *nextp();
		node *prevp();
		friend ostream &operator << (ostream &stream, node *other);
};

node::node()
{
	data = " ";
	next = 0;
	prev = 0;
}

node::~node()
{

}

node::node(char *str)
{
	data = str;
	next = 0;
	prev = 0;
}

node::node(String &indata)
{
	data = indata;
	next = 0;
	prev = 0;
}

void node::connect(node *nodep)
{
	next = nodep;
	nodep->prev = this;  // use of this to connect!
	nodep->next = 0;
}

node *node::nextp() { return next; }

node *node::prevp() { return prev; }

ostream &operator << (ostream &stream, node *other)
{
	stream << other->data;
	return stream;
}

void exhausted()
{
	cout << "Exhausted the free store." << endl;
}

void main()
{
	set_new_handler(exhausted);
	node *head=0;
	node *tail=0;
	
	// a List Head class is left as an exercise
	head = new node("Frank");
	tail = head;
	node *tmp = new node("Mike");
	tail->connect(tmp);
	tail = tmp;
	tmp = new node("Kris");
	tail->connect(tmp);
	tail = tmp;
	tmp = new node("Joe");
	tail->connect(tmp);
	tail = tmp;
	
	// Print list forward and backwards
	node *traverse=0;
	for (traverse = head; traverse; traverse = traverse->nextp() )
		cout << traverse << " ";
	cout << endl;
	
	for (traverse=tail; traverse; traverse = traverse->prevp() )
		cout << traverse << " ";
	cout << endl;
}


