#include <iostream.h>
#include <stdarg.h>
#include <assert.h>
#include <stdlib.h>

template <class T> 
class bndarray {
  T *_storage;
  int _len;
 public:
  bndarray()
  {
    _storage = 0;
    _len = 0;
  }

  ~bndarray()
  {
    delete [] _storage;
  }

  bndarray(long reserve)
    {
      _storage = new T[reserve];
      _len = reserve;
    }

  bndarray(int numelements, ...)
    {
      int i=0;
      va_list ap;
      if (!numelements)
	{
	  _storage=0;
	  _len = 0;
	  return;
	}
      _storage = new T[numelements];
      _len = numelements;
      va_start(ap,numelements);
      for (i=0; i < numelements; i++)
	{
	  _storage[i] = va_arg(ap,T);
	}
      va_end(ap);
    }

  bndarray(bndarray &other)
    {
      int i=0;
      _storage = new T[other._len];
      for (i=0; i < other._len; i++)
	_storage[i] = other._storage[i];
      _len = other._len;
    }

  bndarray &operator =(bndarray &other)
    {
      int i=0;
      if (this == &other)
	return *this;
      _storage = new T[other._len];
      for (i=0; i < other._len; i++)
	_storage[i] = other._storage[i];
      _len = other._len;
      return *this;
    }

  friend ostream &operator << (ostream &stream, bndarray<T> &other)
  {
    int i=0;
    for (i=0; i < other._len; i++)
      stream << other._storage[i] << endl;
    return stream;
  }

  T &operator [] (int index)
    {
      assert(index < _len);
      assert(index >= 0);
      return _storage[index];
    }
};

int main()
{
  bndarray <int> iarray(6,1,2,3,4,5,6);
  bndarray <float> farray(3);
  bndarray <char> carray(4);

  cout << "iarray is: " << endl;
  cout << iarray;

  farray[0] = 1.1;
  farray[1] = 2.2;
  farray[2] = 3.3;
  cout << "farray is: " << endl;
  cout << farray;

  carray[0] = 'm';
  carray[1] = 'i';
  carray[2] = 'k';
  carray[3] = 'e';
  cout << "carray is: " << endl;
  cout << carray;
  return 0;
}

