// stack.cpp
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <new.h>

enum Type { Long, Double, String };

class stack {
		void **storage;
		short *types;
		int top;
		int space;
		void growStack();
	public:
		stack();
		~stack();
		void push(void *val, short type);
		void *pop(short *type);
		friend ostream &operator << (ostream &stream, stack &obj);
};

void stack::growStack()
{
	void **tmp1=0;
	short *tmp2=0;

	tmp1 = new void *[space + 10];
	tmp2 = new short[space + 10];
	
	memcpy(tmp1, storage, sizeof(void *) * space);
	memcpy(tmp2, types, sizeof(short) * space);
	
	delete storage;
	delete types;
	
	storage = tmp1;
	types = tmp2;
	
	space += 10;
}

stack::stack() 
{
	storage = 0; types = 0;
	top = space = 0;
}

stack::~stack()
{
	int i=0;
	
	for (i = 0; i < top; i++)
		delete storage[i];
	
	delete types;
	delete storage;
	storage = 0; types = 0;
	top = space = 0;
}

void stack::push(void *val, short type)
{
	void *tmp=0;
	int len=0;
	if (!val)
		return;
	
	switch (type) {
		case Long:
			tmp = (void *) new long;
			memcpy(tmp,val,sizeof(long));
			break;
		case Double:
			tmp = (void *) new long;
			memcpy(tmp,val,sizeof(long));
			break;
		case String:
			len = strlen((char *)val);
			tmp = (void *)new char[len+1];
			strcpy((char *)tmp,(char *)val);
			break;
		defualt:
			cout << "Unknown type <" << type << ">" << endl;
			return;
	}
	
	if (top == space)
		growStack();
	
	storage[top] = tmp;
	types[top] = type;
	top++;
}

void *stack::pop(short *type)
{
	if (top)
	{
		top--;
		*type = types[top];
		return storage[top];
	}
	else
		cout << "Stack empty!" << endl;
	
	return 0;
}

ostream &operator << (ostream &stream, stack &obj)
{
	int i=0;
	
	cout << "TOP of STACK" << endl;
	for (i=(obj.top-1); i >= 0; i--)
	{
		switch (obj.types[i]) {
			case Long:
				cout << *((long *)obj.storage[i]) << endl;
				break;
			case Double:
				cout << *((double *)obj.storage[i]) << endl;
				break;
			case String:
				cout << ((char *)obj.storage[i]) << endl;
				break;
			defualt:
				cout << "Unknown type <" << obj.types[i] << ">" << endl;
				return stream;
		}	
	}
	return stream;
}

void exhausted()
{
	cout << "Exhausted the free store!" << endl;
	exit(1);
}

int main()
{
	stack mystack;
	long age;
	double gpa;
	
	mystack.push("Lynne",String);
	age = 25; gpa = 3.8;
	mystack.push(&age, Long);
	mystack.push(&gpa, Double);
	
	cout << mystack;
	cout << endl;
	
	void *val;
	short type;
	val = mystack.pop(&type);
	
	cout << mystack;
	return 0;
}



