// gcompare.cpp
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* ***********************************************************
     FUNCTION NAME:  numcmp
     PURPOSE:  treat two strings as numbers, translate them 
               and compare them.
     INPUT:  a - character string containing first number.
			 b - character string containing second number.
     OUTPUT:  an integer representing the result of the compare: 
              a 1 if a > b, 0 if a = b, 
			  else -1.
     AUTHOR: MCD
    ************************************************************ */
int numcmp(char *a, char *b)
{
	double v1,v2;
	
	v1 = atof(a);
	v2 = atof(b);
	
	if (v1==v2)
		return (0);
	else
		return( (v1>v2) ? 1 : -1);
}

/* ***********************************************************
     FUNCTION NAME:  swap
     PURPOSE:  a return to swap two character strings.
     INPUT:  a - a pointer pointer which is the address of 
                 the string from the calling function.
			b - a pointer pointer which is the address of the 
			string from the calling function.
     OUTPUT:  none.
     AUTHOR: MCD
    ************************************************************ */
void swap(char **a, char **b)
{
	char *temp;
	
	temp = *a; *a = *b; *b = temp;
}

/* ***********************************************************
     FUNCTION NAME:  isort
     PURPOSE:  an insertion sort that will work on both character 
               strings and numbers.
     INPUT: cmp - a function pointer to a compare function.
			data - a character pointer pointer which points to 
			       the string array.
			length - the number of strings in the string array.
     OUTPUT:  none.
     AUTHOR: MCD
    ************************************************************ */
void isort(int (*cmp)(char *, char *), char **data, int length)
{
	int i,j;
	
	
	for (i = 1; i < length; i++)
	{
		j = i;
		while ( (j > 0) && ( ((*cmp)(data[j],data[j-1])) < 0 ))
		{
			swap(&(data[j]), &(data[j-1]));
			j--;
		}
	}
}

int mystrcmp(char *s1, char *s2)
{
	return strcmp(s1,s2);
}

/* ***********************************************************
     FUNCTION NAME:  main for generic_compare.c
     PURPOSE:  test the generic insertion sort on test date.
     INPUT:  none.
     OUTPUT:  none.
     AUTHOR: MCD
    ************************************************************ */
void main()
{
	char *ages[10] = { "23", "56", "45", "55", "87", "12", "44", 
	                   "99", "10", "17"};
	char *names[10] = { "john","joe","mike", "bill","bob","mack",
	                    "mary","alice","margaret","lynne"};
	int i;
	
	isort((int (*) (char *, char *)) mystrcmp, names, 10);
	cout << "Names sorted: " << endl;
	for (i = 0; i < 10; i++) cout << names[i] << " ";
	cout << endl << endl;

	cout << "Numbers sorted: " << endl;	
	isort((int (*) (char *, char *)) numcmp, ages, 10);
	for (i = 0; i < 10; i++) cout << ages[i] << " ";
	cout << endl;

}
