// handle.cpp
#include <Memory.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>

struct test {
	char name[80];
	int age;
	float gpa;
	struct test **next;
};

int main()
{
	Handle charpp;
	char *master;
	test **sptr=0;
	test **tail=0, **tmp=0;
	test data;
	int done=0;
	
	charpp = NewHandle(80);  // allocate 80 bytes
	if (!charpp)
	{
		cerr << "Allocation failed!\n";
		exit(1);
	}
	cout << "charpp handle holds " << charpp << endl;
	HLock(charpp);
	master = *charpp;
	cout << "master pointer holds " << (void *) *charpp << endl;
	strcpy(master,"Hello World!");
	cout << "Derefence charpp to " << *charpp << endl;
	cout << "Double dereference charpp to " << **charpp << endl;
	HUnlock(charpp);
	
	// build a small linked list
	while (!done)
	{
		cout << "Enter name or 'exit' : ";
		cin >> data.name;
		if (strcmp(data.name,"exit"))
		{
			tmp = (test **) NewHandle(sizeof(test));
			if (!tmp)
			{
				cerr << "Allocation failed!\n";
				exit(1);
			}
			
			cout << "Enter age: ";
			cin >> data.age;
			
			cout << "Enter gpa: ";
			cin >> data.gpa;
			
			data.next = 0;
			
			HLock((Handle)tmp);
			**tmp = data;
			
			if (sptr)
			{
				(**tail).next = tmp;
				tail = tmp;
			}
			else
			{
				sptr = tmp;
				tail = tmp;
			}
			HUnlock((Handle)tmp);
		}
		else
			done = 1;	
	}
	
	// print out the data list
	for (tmp = sptr; tmp; tmp = (**tmp).next)
	{
		cout << "Name: " << (**tmp).name << endl;
		cout << "Age : " << (**tmp).age << endl;
		cout << "Gpa : " << (**tmp).gpa << endl;
		cout << "-------" << endl;
	}
	

	DisposHandle(charpp);
	return 0;
}
