// size.cpp
// this program will demonstrate how much space objects
// take on the stack.
#include <iostream.h>
#include <iomanip.h>

class base1 {
	protected:
		int a,b;
		int iarray[20];
		char carray[80];
	public:
		base1() { cout << "base constructor" << endl; a=0;b=0;}
		int geta();
		int puta();
};

class deriv1: public base1 {
	protected:
		int c,d;
		double mydoub;
		long mylong;
	public:
		deriv1() { cout << "derived constructor" << endl; c=0; d=0; }
		int getc();
		int putc();
};
		
class deriv2: public deriv1 {
	private:
		int e,f;
		double mydoub2;
		long mylong2;
	public:
		deriv2() { cout << "derived constructor2" << endl; e=0; f=0; }
		int gete();
		int pute();
};

void func1(base1 bobj, deriv1 derobj, deriv2 derobj2)
{
	int bytes=0;

	// let's see how much total stack space we used for
	// objects.
	bytes = (int)(&bobj) - (int)(&derobj2);
	if (bytes < 0) bytes *= -1;	
				
	// now add bytes for last variable
	if ((int)&derobj2 > (int)&bobj)
		bytes += sizeof(derobj2);
	else
		bytes += sizeof(bobj);
	
	// print total bytes on stack
	cout << "Total stack space used for objects is " << bytes << endl;
}

int main()
{
	base1 bobj;
	deriv1 dobj;
	deriv2 dobj2;
	deriv2 *ptr;
	
	cout << "sizeof bobj is " << sizeof(bobj) << endl;
	cout << "sizeof dobj is " << sizeof(dobj) << endl;
	cout << "sizeof dobj2 is " << sizeof(dobj2) << endl;
	func1(bobj,dobj,dobj2);
	cout << "sizeof ptr to deriv2 is " << sizeof(ptr) << endl;
	return 0;
}
