// coord.cpp
#include <iostream.h>
#include <iomanip.h>

#ifdef __TCPLUSPLUS__
#define FALSE 0
#define TRUE 1
#endif

class Coordinate {
	protected:
		int x, y;
	public:
		Coordinate()
		{
			cout << "Calling no-arg constructor" << endl;
			x=0; y=0;
		}
		
		Coordinate(int x1, int y1)
		{
			cout << "Calling one-arg constructor" << endl;
			x=x1; y=y1;
		}
		
		~Coordinate() {} // destructor
		Coordinate operator + (Coordinate& incoord);		
		Coordinate operator - (Coordinate *incoord);
		void operator () (int x1, int y1)
		{
			x = x1; y = y1;
		}
		
		int getx() { return x;}
		int gety() { return y;}
		
		void show(void);
};	

Coordinate Coordinate::operator + (Coordinate& incoord)
{
	Coordinate Temp;
	Temp.x = x + incoord.x;
	Temp.y = y + incoord.y;
	return Temp;
}

Coordinate Coordinate::operator - (Coordinate *incoord)
{
	Coordinate Temp;
	Temp.x = x - incoord->x;
	Temp.y = y - incoord->y;
	return Temp;
}

void Coordinate::show(void)
{
	cout << "x : " << x << endl;
	cout << "y : " << y << endl;
}

class Square {
	protected:
		Coordinate UpperRight, LowerLeft;
	public:
		Square() { UpperRight(0,0); LowerLeft(0,0); }
		Square(Coordinate &UR, Coordinate &LL)
		{
			UpperRight(UR.getx(),UR.gety());
			LowerLeft(LL.getx(),LL.gety());
		}
		
		short PtinSquare(Coordinate& point);
};

short Square::PtinSquare(Coordinate& point)
{
	if ( (point.getx() >= LowerLeft.getx()) &&
		 (point.getx() <= UpperRight.getx()) &&
		 (point.gety() >= LowerLeft.gety()) &&
		 (point.gety() <= UpperRight.gety()) )
		return(TRUE);
	else
		return(FALSE);
}

void main()
{
	Coordinate c1(10,10), c2(2,2);
	Coordinate c3, c4;
	Square S1(c1,c2);
	
	c1.show();
	c2.show();
	c3 = c1 + c2;
	c4 = c1 - &c2;
	c3.show();
	c4.show();
	if (S1.PtinSquare(c4))
		cout << "Coordinate 4 is in Square One." << endl;
	else
		cout << "Coordinate 4 is NOT in Square One." << endl;
}
