// vararg.cpp
#include <iostream.h>
#include <iomanip.h>
#include <stdarg.h>

int sum1(int numargs, ...)
{
	va_list argptr;
	int sum=0,i=0;
	
	va_start(argptr, numargs);
	
	for (i=0; i < numargs; i++)
		sum += va_arg(argptr, int);
		
	va_end(argptr);

	return(sum);
}

int sum2(int first, ...)
{
	va_list argptr;
	int sum=first, *next=NULL;
	
	va_start(argptr, first);
	
	while ( (next = va_arg(argptr, int *)) != NULL)
		sum += *next;
	
	va_end(argptr);
	
	return(sum);
}

void main()
{
	int total1=0, total2=0, total3=0, total4 = 0;
	int i1=10, i2=20, i3=30, i4=40, i5=50;
	int i6=60, i7=70, i8=80, i9=90, i10=100;
	
	total1 = sum1(5, 1, 2, 3, 4, 5);
	cout << "total1 is " << total1 << endl;
	
	total2 = sum1(2, 10, 10);
	cout << "total2 is " << total2 << endl;
	
	total3 = sum2(i1, &i2, &i3, &i4, NULL);
	cout << "total3 is " << total3 << endl;
	
	total4 = sum2(i6, &i10, NULL);
	cout << "total4 is " << total4 << endl;
}
