// bounds.cpp
#include <iostream.h>
#include <iomanip.h>
#include <assert.h>
#include <stdarg.h>

const int MAX = 100;

class iArray {
	protected:
		int _storage[101];
		int _sz;
	public:
		iArray() { _sz = 0; }
		iArray(int size)
		{
			assert(size < MAX);			
			_sz = size;
		}
		
		~iArray() { }
		
		int &operator [](int index)
		{
			assert(index < _sz);
			assert(index >= 0);
			return _storage[index];
		}
		
		operator int *()
		{ 	return _storage; }
		
		int bytes()
		{ 	return sizeof(int) * _sz; }
		
		int len()
		{	return _sz; }
		
		void fill(int numelements, ...);
		void print();
};

void iArray::fill(int numelements, ...)
{
	va_list argptr;
	int i=0;
	va_start(argptr, numelements);
	
	assert(numelements <= _sz);
	for (i=0; i < _sz; i++)
	{
		if (i < numelements)
			_storage[i] = va_arg(argptr, int);
		else
			_storage[i] = 0;
	}
}

void iArray::print()
{
	int i=0;
	cout << "Array Contents:" << endl;
	for (i=0; i < _sz; i++)
	{
		if (i && (!(i%5)))
			cout << endl;
		cout << _storage[i] << " ";
	}
	cout << endl;
}

void main()
{
	iArray myarray(10);
	myarray.fill(10,1,2,3,4,5,6,7,8,9,10);
	myarray.print();
	myarray[4] = 99;
	myarray.print();
	myarray[12] = 99;  // will cause a runtime boundary error.
}
