// traverse.cpp
#include <iostream.h>
#include <iomanip.h>
#include <assert.h>
#include <string.h>
#include <ctype.h>

#include "strlib.h"  // this file has the String class declaration

// these functions will also be added to strlib.cpp

/* ***********************************************************
     FUNCTION NAME:  pad
     PURPOSE: pad a string to a specified length.
     INPUT:   padchar - character to pad the string with.
              padlen - length for resultant string.
     OUTPUT:  an integer which represents the number of characters in the string.
     AUTHOR: MCD
    ************************************************************ */
/*  *** added to strlib.cpp
void String::pad(char pad_char, int pad_len)
{
	int i=0;
	assert(pad_len < MAX);
	for (i=_sz; i < pad_len; i++)
		_storage[i] = pad_char;
	_storage[pad_len] = '\0';
}
*/
/* ***********************************************************
     FUNCTION NAME:  slen
     PURPOSE:  determine the length of the input string.  A mimic of strlen.
     OUTPUT:  an integer which represents the number of characters in the string.
     AUTHOR: MCD
    ************************************************************ */
/*  added to strlib.cpp
int String::slen()
{
	int i;
	
	for (i=0; *(_storage+i); ++i);
	return(i);
}
*/
/* ***********************************************************
     FUNCTION NAME:  search
     PURPOSE:  the routine searches for a substring within a string and returns the index
				of the start of the substring in the string.
     INPUT:  word - character string to search for.
     OUTPUT:  an integer which is the index in the searchstr where the word starts.
     AUTHOR: MCD
    ************************************************************ */
/*  added to strlib.cpp
int String::search(char *word)
{
	int idx,i,j;
	char *searchstr = _storage;
	
	for (i=0; searchstr[i]; i++)
	{
		if (searchstr[i] == word[j])
		{
			if (!j) idx = i;
			j++;
		}
		else
			j = 0;
		
		if (word[j] == '\0')
			break;
	}

	if (word[j] != '\0')
		return(-1);
	else
		return(idx);
}
*/
/* ***********************************************************
     FUNCTION NAME:  reverse
     PURPOSE:  reverse the characters in the input string.
     INPUT:  reverse - the character string to store the reversed characters.
     OUTPUT:  none.
     AUTHOR: MCD
    ************************************************************ */
/*  added to strlib.cpp
String String::reverse()
{
	int i=0, len=0;
	String temp;
	char *reverse = temp._storage;
	char *instr = _storage;
	
	len = _sz;	
	reverse[len] = '\0';
	while (instr[i] != '\0')
		reverse[--len] = instr[i++];
	return temp;				
}
*/
/* ***********************************************************
     FUNCTION NAME:  main for traverse.c
     PURPOSE:  examples on the use of the above string functions.
     INPUT:  none.
     OUTPUT:  none.
     AUTHOR: MCD
    ************************************************************ */
void main()
{
	String name;
	String padded_name;
	String quote;
	String reverse_name;
	
	int index;
	
	// we will look at four types of string operations:
	//	padding, counting, searching, reversing.
	
	// first let's load some test data into our strings.
	name = "Michael Daconta";
	quote = "The C language has brought forth a new era in computing";
	
	// test of padding
	cout << "Name is " << name << endl;
	padded_name = name;
	padded_name.pad('*',30);
	cout << "Padded Name is " << padded_name << endl;	
	
	// test of length routine
	cout << "the length of :" << endl;
	cout << "<" << quote << ">" << " is " << quote.slen() << endl;
	
	// test of search which mimics strstr()
	index = quote.search("forth");
	
	if (index != -1)
	{
		cout << "The index of \"forth\" in " << endl << quote;
		cout << " is " << index << endl;
	}
	else
		cout << "forth is not in " << endl << quote << endl;
		
	// test of reverse		
	reverse_name = name.reverse();
	cout << "My name is " << name << endl;
	cout << "My reverse name is " << reverse_name << endl;	
}
