// tinydict.cpp
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <assert.h>
#include <stdarg.h>

#include "dynstrlb.h"
#include "tinydict.h"

dictionary_entry::dictionary_entry()
{
	int i;
	keyword = " ";
	for (i=0; i < SENTENCE_MAX; i++)
		sentence[i] = " ";
}

dictionary_entry::~dictionary_entry()
{

}

String dictionary_entry::get_keyword()
{
	return keyword;
}

ostream &operator << (ostream &stream, dictionary_entry &inobj)
{
	int i=0;
	stream << "Keyword: " << inobj.keyword << endl;
	for (i=0; i < SENTENCE_MAX; i++)
		stream << "#" << i << ": " << inobj.sentence[i] << endl;
	return stream;
}

istream &operator >> (istream &stream, dictionary_entry &inobj)
{
	int i=0;
	cout << "Enter Keyword: ";
	stream >> inobj.keyword;
	stream.ignore(2,'\n');
	
	cout << "Enter " << SENTENCE_MAX << " line definition:" << endl;
	for (i=0; i < SENTENCE_MAX; i++)
	{
		cout << "#" << i << ": ";
		inobj.sentence[i].getline(stream);
	}
	return stream;
}

dictionary::dictionary()
{

}

dictionary::~dictionary()
{

}

void dictionary::add_entry()
{
	cin >> listing[entry_count];
	entry_count++;
}

void dictionary::delete_entry()
{
	cout << "Stub code" << endl;
}

void dictionary::list_entries()
{
	int i=0;
	cout << "Dictionary Listing:" << endl;
	for (i=0; i < entry_count; i++)
		cout << "Entry #" << i << ": "
		     << listing[i].get_keyword() << endl;
}

void dictionary::find_entry()
{
	int i=0;
	String key;
	cout << "Enter keyword to find: ";
	cin >> key;
	for (i=0; i < entry_count; i++)
	{
		if (key == listing[i].get_keyword())
		{
			cout << "Entry # " << i << endl;
			cout << listing[i];
			break;
		}
	}

	if (i== entry_count)
		cout << "No match for " << key << endl;
}

menu::menu()
{
	num_choices = 0;
	choice = -1;
}
		
menu::menu(int numstrings, int inheader, int intrailer,...)
{
	va_list argptr;
	int i=0;

	va_start(argptr,intrailer);
	num_choices = numstrings;
	choice=-1;
	for (i=0; i < numstrings; i++)
		choices[i] = va_arg(argptr,char *);	
	va_end(argptr);
}

ostream &operator << (ostream &stream, menu &inobj)
{
	int i=0;
	for (i=0; i < inobj.num_choices; i++)
		stream << inobj.choices[i] << endl;
	return stream;
}

int menu::menu_choice()
{
	int pick= -1;
	
	cout << "Choice: ";
	cin >> pick;
	
	return pick;
}

// make global so not to chew up stack space
dictionary webster;

void main()
{
	int done=0;
	menu todo(5,1,0,"<<<< Your-Webster >>>>",
					"1) enter a definition.",
					"2) list all entries.",
					"3) display an entry.",
					"4) exit.");
	while (!done)
	{
		cout << todo;
		switch (todo.menu_choice()) {
			case 1:
					webster.add_entry();
				break;
			case 2:
					webster.list_entries();
				break;
			case 3:
					webster.find_entry();
				break;
			case 4:
				done=1;
				break;
			default:
				cout << "Invalid Choice. Try again." << endl;
		}
	}
}
