// intalloc.cpp
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <stdarg.h>
#include <assert.h>

void exhausted()
{	
	cout << "The free store is exhausted." << endl;
	exit(0);
}

class intarray {
	protected:
		int *_storage;
		int _len;
	public:
		intarray();
		intarray(int num);
		intarray(short num, ...);
		~intarray();
		int &operator [](int index);
};

intarray::intarray()
{
	_storage = 0;
	_len = 0;
}

intarray::intarray(int num)
{
	int i;
	
	cout << "Calling the intarray constructor." << endl;
	_storage = new int[num];
	for (i=0; i < num; i++)
		_storage[i] = 0;
	_len = num;
}

intarray::intarray(short num, ...)
{
	int i;
	va_list ap;
	
	cout << "Calling the intarray constructor." << endl;
	_storage = new int[num];
	va_start(ap,num);
	for (i=0; i < num; i++)
		_storage[i] = va_arg(ap,int);
	_len = num;
	va_end(ap);
}

intarray::~intarray()
{
	cout << "Calling the intarray destructor." << endl;
	delete _storage;
	_len=0;
}

int &intarray::operator [](int index)
{
	assert(index < _len);
	return _storage[index];
}

long calculate(int cnt)
{
	int i=0;
	intarray scratch(cnt);
	long sum=0, average=0;
	
	for (i=0; i < cnt; i++)
	{
		cout << "Enter number: ";
		cin >> scratch[i];
	}

	for (i=0; i < cnt; i++)
	{
		sum += scratch[i];
	}
	
	average = sum/cnt;
	return sum;
}

void main()
{
	cout << "Sum of 4 is:" << endl;
	cout << calculate(4) << endl;
	cout << "Sum of 2 is:" << endl;
	cout << calculate(2) << endl;
}
