// ovldasgn.cpp
#include <iostream.h>
#include <iomanip.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <new.h>

class Charstr {
	protected:
		char _objname[32];
		char *_str;
	public:
		Charstr();
		Charstr(char *inname);
		Charstr(char *inname,char *instr);
		~Charstr();
		Charstr(Charstr &obj);  // *** COPY CONSTRUCTOR ***
		Charstr &operator = (Charstr &inobj);  // *** OVERLOADED = ***
		friend ostream &operator << (ostream &stream, Charstr &inobj);
		Charstr reverse();
};

void exhausted()
{
	cout << "Free store is exhausted!" << endl;
	exit(0);
}

Charstr::Charstr()
{
	cout << "No-Arg Charstr Contructor." << endl;
	_str = 0;
}

Charstr::Charstr(char *inname)
{
	cout << "One-Arg Charstr Contructor for " 
	     << inname << endl;
	assert(strlen(inname) < 32);
	strcpy(_objname,inname);
	_str = 0;
}

Charstr::Charstr(char *inname,char *instr)
{
	cout << "Two-Arg Charstr constructor for " << inname << endl;
	assert(instr);
	_str = new char[strlen(instr) + 1];  // Don't forget one for Nul!!!
	strcpy(_str,instr);
	assert(strlen(inname) < 32);
	strcpy(_objname,inname);
}

Charstr::Charstr(Charstr &obj)
{
	cout << "Calling Copy Constructor for " << obj._objname << endl;
	_str = new char[strlen(obj._str) + 1];
	strcpy(_str,obj._str);
	strcpy(_objname,obj._objname);
}

Charstr::~Charstr()
{
	cout << "Charstr destructor for " << _objname << endl;
	cout << "Freeing pointer " << (void *)_str << endl;
	delete _str;
}

Charstr &Charstr::operator = (Charstr &inobj)
{
	// delete previous
	delete _str;
	
	// allocate new
	_str = new char[strlen(inobj._str) + 1];
	strcpy(_str,inobj._str);
	return *this;
}

Charstr Charstr::reverse()
{
	Charstr temp;
	int len=0,i=0,j=0;
	
	cout << "reversing object " << _objname << endl;
	strcpy(temp._objname,"temp");
	len = strlen(_str);
	temp._str = new char[len + 1];
	for (i=(len-1),j=0; j<len; i--,j++)
		temp._str[j] = _str[i];
	temp._str[len] = '\0';
	cout << "returning temp." << endl;
	return temp;
}

ostream &operator << (ostream &stream, Charstr &inobj)
{
	stream << "obj: " << inobj._objname << endl;
	stream << "str: " << inobj._str << endl;
	return stream;
}

void func1(Charstr inobj)
{
	cout << inobj;
}

void main()
{
	Charstr c2("c2","Jack");
	set_new_handler(exhausted);
	cout << c2;
	
	// now let's demonstrate the overloaded assignment
	Charstr c3("c3");
	c3 = c2.reverse();
	cout << "After reverse, printing c3" << endl;
	cout << c3;
}
